local AddOn, NS = ...

NS.DUF_VERSION = "10.2"
NS.DUF_SUBVERSION = ".4"
NS.DUF_DL_VERSION = 10.0

local function StrFunc() return "" end
local function NilFunc() end
local function NumFunc() return 0, 0 end
local function OneFunc() return 1, 1 end
NS.GetPetHappiness = GetPetHappiness or NilFunc
--NS.GetPetExperience = GetPetExperience or NilFunc
NS.UnitGroupRolesAssigned = UnitGroupRolesAssigned or NilFunc
NS.GetPVPRankProgress = GetPVPRankProgress or NumFunc
NS.GetPVPRankInfo = GetPVPRankInfo or NumFunc
NS.UnitPVPRank = UnitPVPRank or NumFunc
NS.GetSpecialization = GetSpecialization or OneFunc
NS.UnitPhaseReason = UnitPhaseReason or NilFunc
NS.UnitIsQuestBoss = UnitIsQuestBoss or NilFunc
NS.UnitCastingInfo = UnitCastingInfo or NilFunc
NS.UnitChannelInfo = UnitChannelInfo or  NilFunc

if GetPetExperience then
        NS.GetPetExperience = GetPetExperience
else -- if GetPetExperience is gone, peg pet XP to player XP so there's at least something to see
        NS.GetPetExperience = function()  -- for clients where pet xp is not a seperate thing ie. not tracked
                return UnitXP("player"), UnitXPMax("player")
        end
        hooksecurefunc(NS, "DUF_XPBar_Update", NS.DUF_PetXPBar_Update)
end

NS.UNIT_HEALTH_EVENT = "UNIT_HEALTH_FREQUENT"
if WOW_PROJECT_ID == WOW_PROJECT_MAINLINE then
        NS.UNIT_HEALTH_EVENT = "UNIT_HEALTH"
end

NS.DUF_ISDRUID = nil
NS.DUF_ISSHAPESHIFTED = nil

NS.DUF_NUM_STATUSBARS = 8
NS.DUF_NUM_PLAYER_TEXTBOXES = 11
NS.DUF_NUM_OTHERS_TEXTBOXES = 10

NS.Bar = {
        Health = 1,
        Power = 2,
        XP = 3,
        TargetHealth = 4,
        TargetPower = 5,
        Cast = 6,
        AltMana = 7,
        Honor = 8,
}

NS.ALTPOWERTYPES = {
--        [SPELL_POWER_MAELSTROM]="MAELSTROM",
        [Enum.PowerType.Maelstrom]="MAELSTROM",
--        [SPELL_POWER_LUNAR_POWER]="LUNAR",
        [Enum.PowerType.LunarPower]="LUNAR",
--        [SPELL_POWER_INSANITY]="INSANITY",
        [Enum.PowerType.Insanity]="INSANITY",
}

DUF_OPTIONS_SCALES = {
        { text="100", value=1 },
        { text="90", value=.9 },
        { text="80", value=.8 },
        { text="70", value=.7 },
        { text="60", value=.6 },
        { text="50", value=.5 },
}

DUF_DEFAULT_SETTINGS = {}
DUF_ELEMENT_INDEX = nil
DUF_ELEMENTS_UNLOCKED = nil
DUF_FRAME_INDEX = nil
DUF_FRAMES_UNLOCKED = nil
DUF_INITIALIZED = nil

DUF_FRAME_NOP_VERSIONS = {}
if WOW_PROJECT_ID == WOW_PROJECT_CLASSIC then
        DUF_FRAME_NOP_VERSIONS.boss = true
        DUF_FRAME_NOP_VERSIONS.focus = true
end
if WOW_PROJECT_ID == WOW_PROJECT_BURNING_CRUSADE_CLASSIC then
        DUF_FRAME_NOP_VERSIONS.boss = true
end

DUF_PARTY_DATA = {
        party1 = { frame="DUF_PartyFrame1", index="party", elements={} },
        party2 = { frame="DUF_PartyFrame2", index="party", elements={} },
        party3 = { frame="DUF_PartyFrame3", index="party", elements={} },
        party4 = { frame="DUF_PartyFrame4", index="party", elements={} },
        partypet1 = { frame="DUF_PartyPetFrame1", index="partypet", elements={} },
        partypet2 = { frame="DUF_PartyPetFrame2", index="partypet", elements={} },
        partypet3 = { frame="DUF_PartyPetFrame3", index="partypet", elements={} },
        partypet4 = { frame="DUF_PartyPetFrame4", index="partypet", elements={} },
}

DUF_FRAME_DATA = {
        player = { frame="DUF_PlayerFrame", index="player", elements= {"XPBar", "HonorBar", "TempEnchants", "ComboPoints"} },
        party1 = { frame="DUF_PartyFrame1", index="party", elements={} },
        party2 = { frame="DUF_PartyFrame2", index="party", elements={} },
        party3 = { frame="DUF_PartyFrame3", index="party", elements={} },
        party4 = { frame="DUF_PartyFrame4", index="party", elements={} },
        target = { frame="DUF_TargetFrame", index="target", elements={} },
        pet = { frame="DUF_PetFrame", index="pet", elements={"HappinessIcon", "PetXPBar"}, attachindex = 1 },
        partypet1 = { frame="DUF_PartyPetFrame1", index="partypet", elements={} },
        partypet2 = { frame="DUF_PartyPetFrame2", index="partypet", elements={} },
        partypet3 = { frame="DUF_PartyPetFrame3", index="partypet", elements={} },
        partypet4 = { frame="DUF_PartyPetFrame4", index="partypet", elements={} },
        targettarget = { frame="DUF_TargetOfTargetFrame", index="targettarget", elements={} },
        boss1 = { frame="DUF_BossFrame1", index="boss", elements={} },
        boss2 = { frame="DUF_BossFrame2", index="boss", elements={} },
        boss3 = { frame="DUF_BossFrame3", index="boss", elements={} },
        boss4 = { frame="DUF_BossFrame4", index="boss", elements={} },
        boss5 = { frame="DUF_BossFrame5", index="boss", elements={} },
        focus = { frame="DUF_FocusFrame", index="focus", elements={} },
}
--        vehicle = { frame="DUF_PetFrame", index="pet", elements={"PetXPBar"}, attachindex = 1 },

DUF_FRAME_INDICES = { "player", "pet", "party", "target", "partypet", "targettarget", "focus", "boss" }
DUF_ELEMENT_INDICES = { "TextBox", "StatusBar", "StatusIcon", "PVPIcon", "LootIcon", "LeaderIcon", "Debuffs", "Buffs", "Portrait", "ClassIcon", "RaceIcon", "RoleIcon", "TempEnchants" }
DUF_STATUSBARS = { "_HealthBar", "_ManaBar", "_XPBar", "_TargetHealthBar", "_TargetManaBar", "_CastBar", "_AltManaBar", "_HonorBar"} --

DUF_UNIT_CHANGED_EVENTS = {
        pet = "UNIT_PET",
        partypet1 = "UNIT_PET",
        partypet2 = "UNIT_PET",
        partypet3 = "UNIT_PET",
        partypet4 = "UNIT_PET",
        party1 = "GROUP_ROSTER_UPDATE",
        party2 = "GROUP_ROSTER_UPDATE",
        party3 = "GROUP_ROSTER_UPDATE",
        party4 = "GROUP_ROSTER_UPDATE",
        target = "PLAYER_TARGET_CHANGED",
}
if FocusFrame then
        DUF_UNIT_CHANGED_EVENTS.focus = "PLAYER_FOCUS_CHANGED"
end

DUF_TEXT_OUTLINES = {
        {text="NONE", value=nil},
        {text="NORMAL", value="NORMAL"},
        {text="THICK", value="THICK"}
}

DUF_FRAME_CHOICES = {} -- Number of frames in group (party, boss etc.) or 1
